<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyyMMdd").format(new Date());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;
var moveDateIsValid = false;

function init()
{
	var frm = document.forms['reggie'];

	var plates = getHistologyPlates();
	
	var plateList = frm.plates;
	if (plates != null && plates.length > 0)
	{
		for (var i=0; i < plates.length; i++)
		{
			var plate = plates[i];
			var option = new Option(plate.name + ' -- ' + plate.usedWells + ' used wells', plate.id);
			option.plate = plate;
			plateList.options[plateList.length] = option;
		}
		moveDateOnChange();
		Main.show('gocreate');
	}
	else
	{	
		setFatalError('No Histology plates with at least 5 samples could be found.');
	}
}

function getHistologyPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading histology plates...');
		var url = 'Histology.servlet?ID=<%=ID%>&cmd=GetHistologyPlates';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.plates;
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	Main.hide('navigation');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	else if (currentStep == 2)
	{
		gotoStep3();
	}
	Main.show('navigation');
}

function step1IsValid()
{
	var frm = document.forms['reggie'];

	return true;
}

function gotoStep2()
{
	if (!step1IsValid()) return;
	
	var frm = document.forms['reggie'];
	
	currentStep = 2;
}

function goCreate()
{
	var frm = document.forms['reggie'];

	if (frm.moveDate.value != '' && !moveDateIsValid) return;
	
	Main.hide('gocreate');

	var plateId = frm.plates[frm.plates.selectedIndex].value;
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Moving histology samples to paraffin blocks...');
		var url = 'Histology.servlet?ID=<%=ID%>&cmd=MoveHistologySamplesToParaffinBlocks&plateId='+plateId;
		url += '&moveDate=' + frm.moveDate.value;
		request.open("POST", url, false);
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		var msgLine = response.messages[i];
		if (msgLine.indexOf('[Warning]') >= 0)
		{
			msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
		}
		else
		{
			msg += '<li>' + msgLine;
		}
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');
	
	var blocks = response.paraffinBlocks;
	if (blocks && blocks.length > 0)
	{
		var printFrm = document.forms['print'];
		for (var i = 0; i < blocks.length; i++)
		{
			Forms.createHidden(printFrm, 'plates', blocks[i].id);
		}
		Main.show('goprint');
	}
	
}

function goPrint()
{
	var printFrm = document.forms['print'];
	printFrm.submit();
}

function moveDateOnChange()
{
	var frm = document.forms['reggie'];
	moveDateIsValid = false;
	setInputStatus('moveDate', '', '');
	
	var moveDate = frm.moveDate.value;
	
	if (moveDate == '')
	{
		setInputStatus('moveDate', 'Missing', 'warning');
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
		moveDate = autoFillDate(moveDate);
		frm.moveDate.value = moveDate;
	
		if (!Dates.isDate(moveDate, 'yyyyMMdd'))
		{
			setInputStatus('moveDate', 'Not a valid date', 'invalid');
			return;
		}
		setInputStatus('moveDate', '', 'valid');
	}
	
	moveDateIsValid = true;
}

</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Move Histology samples to paraffin blocks" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 800px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select Histology storage plate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Histology plate</td>
				<td class="input"><select style="width:90%" name="plates" id="plates"></select>
				</td>
				<td class="status" id="plate.status"></td>
				<td class="help"><span id="plate.message" class="message" style="display: none;"></span>
					The list contain all Histology plates with at least 5 samples on it.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Date</td>
				<td class="input" style="padding-left: 0px;">
					<input type="text" name="moveDate" value="<%=today%>" size="12" maxlength="10" 
						onblur="moveDateOnChange()">
				</td>
				<td class="status" id="moveDate.status"></td>
				<td class="help">
					<span id="moveDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 800px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 800px; margin-left: 20px; margin-top: 10px;"></div>
	
	<div id="goprint" style="display: none; width: 800px; margin-left: 36px; margin-top: 20px;">
		<a href="javascript:goPrint();"><img src="images/print.png">&nbsp;Create/print lab tracking protocol</a>
	</div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	
	<form name="print" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>