<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	
<script language="JavaScript">

var debug = false;
var currentStep = 1;
var pnrIsValid = false;
var pnrIsAcceptable = false;
var caseIsValid = false;
var lateralityIsValid = false;
var samplingDateIsValid = true;
var rnaLaterDateIsValid = true;

var patientInfo = null;
var caseInfo = null;
var bloodInfo = null;

var copyConsentEnabled = false;

function init()
{
	var frm = document.forms['reggie'];
	frm.caseName.focus();
}

function step1IsValid()
{
	return pnrIsValid && caseIsValid;
}

function step1IsAcceptable()
{
	return pnrIsAcceptable && caseIsValid;
}

function step2IsValid()
{
	var formOk = true;
	var frm = document.forms['reggie'];

	// New patient only
	if (!patientInfo.id)
	{
		// Validate 'New patient' form
		if (frm.allFirstNames.value == '')
		{
			setInputStatus('allFirstNames', 'Missing', 'invalid');
			frm.allFirstNames.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('allFirstNames', '', 'valid');
		}
		
		if (frm.familyName.value == '')
		{
			setInputStatus('familyName', 'Missing', 'invalid');
			frm.familyName.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('familyName', '', 'valid');
		}

		if (frm.patientCode.value == '')
		{
			setInputStatus('patientCode', 'Missing', 'invalid');
			frm.patientCode.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('patientCode', '', 'valid');
		}	
	}
	else // existing patient
	{
		if (frm.existingAllFirstNames.value == '')
		{
			setInputStatus('existingAllFirstNames', 'Missing', 'invalid');
			frm.existingAllFirstNames.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('existingAllFirstNames', '', 'valid');
		}
		
		if (frm.existingFamilyName.value == '')
		{
			setInputStatus('existingFamilyName', 'Missing', 'invalid');
			frm.existingFamilyName.focus();
			formOk = false;
		}
		else
		{
			setInputStatus('existingFamilyName', '', 'valid');
		}
		
	}
	return formOk;
}

function step3IsValid()
{
	var isValid = lateralityIsValid && samplingDateIsValid;
	if (caseInfo.specimen && caseInfo.specimen.length > 0)
	{
		isValid = isValid && rnaLaterDateIsValid;
	}
	return isValid;
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	var frm = document.forms['reggie'];
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid())
		{
			gotoStep2();
		}
		else if (step1IsAcceptable())
		{
			if (manual)
			{
				gotoStep2();
			}
			else
			{
				frm.personalNumber.focus();
				setInnerHTML('gonext.message', 'Personal number is non-standard. Click \'Next\' to continue registration.');
			}
		}
	}
	else if (currentStep == 2)
	{
		if (step2IsValid()) gotoStep3();
	}
}

function caseNameOnChange()
{
	var frm = document.forms['reggie'];
	var caseName = frm.caseName.value;
	caseIsValid = false;
	if (caseName == '')
	{
		setInputStatus('case', 'Missing', 'invalid');
		frm.caseName.focus();
		return;
	}
	if (!isValidCaseName(caseName, true)) // Allow 'C' suffix to be used
	{
		setInputStatus('case', 'Only 7-digits name + optional \'C\' is allowed .', 'invalid');
		frm.caseName.focus();
		return;
	}

	setInputStatus('case', '', 'valid');
	caseIsValid = true;
	
	getCaseInfo();
}

function personalNumberOnChange()
{
	var frm = document.forms['reggie'];
	var pnr = frm.personalNumber.value;
	pnrIsValid = false;
	pnrIsAcceptable = true;
	
	var pnrLen = pnr.length;
	if (pnrLen != 12 && pnrLen != 10)
	{
		setInputStatus('pnr', pnrLen < 12 ? 'Too short' : 'Too long', 'warning');
		return;
	}

	if (!pnr.match(/^\d+$/))
	{
		setInputStatus('pnr', 'Non-standard personal number', 'warning');
		return;
	}
	
	var datePart = pnr.substring(0, pnrLen - 4); // Remove last four digits
	var dateFormat = pnrLen == 10 ? 'yyMMdd' : 'yyyyMMdd';
	var isValidDate = Dates.isDate(datePart, dateFormat);
	if (!isValidDate)
	{
		var dayInMonth = parseInt(datePart.substring(-2)); // Last two characters
		if (dayInMonth > 60)
		{
			// 'Samordningsnummer' has day-in-month + 60; check this
			dayInMonth -= 60;
			var tmpPnr = pnr.substring(0, pnrLen - 6); // First 4 or 6 digits is year+month
			if (dayInMonth < 10) tmpPnr += '0';
			tmpPnr += dayInMonth;
			isValidDate = Dates.isDate(tmpPnr, dateFormat);
		}
	}
	if (!isValidDate)
	{
		setInputStatus('pnr', 'Not a valid date', 'warning');
		return;
	}
	
	if (!personalNumberControlDigitCheck(pnr.substr(pnrLen == 10 ? 0 : 2)))
	{
		setInputStatus('pnr', 'Invalid control digit', 'warning');
		return;
	}

	setInputStatus('pnr', '', 'valid');
	pnrIsValid = true;
}

function lateralityOnChange()
{
	lateralityIsValid = false;
	var updateMode = caseInfo.id;
	
	// Check selected laterality against specimen tubes
	var frm = document.forms['reggie'];
	var selectedLaterality = Forms.getCheckedRadio(frm.laterality);
	
	// No laterality/case selected
	if (selectedLaterality == null) 
	{
		setInputStatus('laterality', 'Not selected', 'invalid');
		return;
	}
	
	var numCases = patientInfo.cases ? patientInfo.cases.length : 0;
	setInputStatus('laterality', updateMode && numCases > 1 ? 'NOTE! Some alternatives may be missing if there is another case for the patient.' : '', 'valid');
	lateralityIsValid = true;
		
	var laterality = selectedLaterality.value;
	if (laterality.match(/\d+/))
	{
		// It is the ID of an existing case
		for (var i = 0; i < patientInfo.cases.length; i++)
		{
			var cse = patientInfo.cases[i];
			if (cse.id == laterality)
			{
				laterality = cse.laterality;
				break;
			}
		}
	}
	else if (laterality == '') 
	{
		laterality = null;
	}
	
	// If the selected laterality/case is not the same as the other case with consent enable the copy consent option
	Main.showHide('copyConsentSection', copyConsentEnabled && selectedLaterality.value != frm.copyConsent.value);
		
	// No specimen tubes?
	if (!caseInfo.specimen || caseInfo.specimen.length == 0) return;
	
	for (var i = 0; i < caseInfo.specimen.length; i++)
	{
		var specimen = caseInfo.specimen[i];
		if (specimen.laterality != laterality)
		{
			if (specimen.laterality == null || updateMode)
			{
				setInputStatus('laterality', 'Specimen tubes are updated to: ' + laterality, 'valid')
			}
			else
			{
				setInputStatus('laterality', 'Not same laterality as specimen tubes', 'warning');
			}
			return;
		}
	}
	
}

function padOnChange()
{
	var frm = document.forms['reggie'];
	var PAD = frm.pad.value;
	if (PAD == '')
	{
		setInputStatus('pad', 'Missing', 'warning');
		return;
	}
	frm.pad.value = PAD.replace(/\+/, '-');
	setInputStatus('pad', '', 'valid');
}

function samplingDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	samplingDateIsValid = false;
	setInputStatus('samplingDate', '', '');
	
	var samplingDate = frm.samplingDate.value;
	var samplingTime = frm.samplingTime.disabled ? null : frm.samplingTime.value;
	
	if (samplingDate != '' || samplingTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		samplingDate = autoFillDate(samplingDate);
		frm.samplingDate.value = samplingDate;

		if (!frm.samplingTime.disabled)
		{
			samplingTime = autoFillTime(samplingTime);
			frm.samplingTime.value = samplingTime;
		}
		
		if (!Dates.isDate(samplingDate, 'yyyyMMdd'))
		{
			setInputStatus('samplingDate', 'Not a valid date', 'invalid');
			return;
		}
		if (frm.rnaLaterDate.value == '') frm.rnaLaterDate.value = samplingDate;
		
		if (!frm.samplingTime.disabled)
		{
			if (!Dates.isDate(samplingDate + ' ' + samplingTime, 'yyyyMMdd HHmm'))
			{
				if (samplingDate != '') setInputStatus('samplingDate', 'Not a valid time', 'invalid');
				return;
			}
		}
		setInputStatus('samplingDate', '', 'valid');
	}
	samplingDateIsValid = true;
}

function rnaLaterDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	rnaLaterDateIsValid = false;
	setInputStatus('rnaLaterDate', '', '');
	
	var rnaLaterDate = frm.rnaLaterDate.value;
	var rnaLaterTime = frm.rnaLaterTime.value;
	var rnaLaterTimestamp;
	
	if (rnaLaterDate != '' || rnaLaterTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		rnaLaterDate = autoFillDate(rnaLaterDate);
		frm.rnaLaterDate.value = rnaLaterDate;

		rnaLaterTime = autoFillTime(rnaLaterTime);
		frm.rnaLaterTime.value = rnaLaterTime;
		
		if (!Dates.isDate(rnaLaterDate, 'yyyyMMdd'))
		{
			setInputStatus('rnaLaterDate', 'Not a valid date', 'invalid');
			return;
		}
		rnaLaterTimestamp = Dates.parseString(rnaLaterDate + ' ' + rnaLaterTime, 'yyyyMMdd HHmm');
		if (rnaLaterTimestamp == null)
		{
			if (rnaLaterDate != '') setInputStatus('rnaLaterDate', 'Not a valid time', 'invalid');
			return;
		}
		setInputStatus('rnaLaterDate', '', 'valid');
	}
	
	rnaLaterDateIsValid = true;

	if (samplingDateIsValid && rnaLaterTimestamp && !frm.samplingTime.disabled)
	{
		var samplingTimestamp = Dates.parseString(frm.samplingDate.value + ' ' + frm.samplingTime.value, 'yyyyMMdd Hmm');
		if (samplingTimestamp && rnaLaterTimestamp.getDate() != samplingTimestamp.getDate())
		{
			setInputStatus('rnaLaterDate', 'Sampling and RNA later dates are different', 'warning');
		}
	}
}

function getCaseInfo()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	var caseName = frm.caseName.value;
	var request = Ajax.getXmlHttpRequest();
	var url = 'PersonalRegistration.servlet?ID=<%=ID%>&cmd=GetCaseInfo';
	url += '&caseName=' + caseName;
	request.open("GET", url, false); 
	request.send(null);
	
	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	// Get biosource information from the AJAX response
	caseInfo = response.caseInfo;
	bloodInfo = response.bloodInfo;
	
	if (caseInfo && caseInfo.patient)
	{
		frm.personalNumber.value = caseInfo.patient.personalNumber;
		gotoStep2();
	}
	else if (bloodInfo && bloodInfo.patient)
	{
		frm.personalNumber.value = bloodInfo.patient.personalNumber;
		gotoStep2();
	}
}

function gotoStep2()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	frm.caseName.disabled = true;
	frm.personalNumber.disabled = true;
	currentStep = 2;
	
	var pnr = frm.personalNumber.value;
	if (pnr.length == 10 && pnrIsValid) 
	{
		var year = fullYear(parseInt(pnr.substr(0, 2)));
		pnr = year + pnr.substr(2);
	}
	var request = Ajax.getXmlHttpRequest();
	var url = 'PersonalRegistration.servlet?ID=<%=ID%>&cmd=GetPatientInfo';
	url += '&personalNumber=' + pnr;
	url += '&pnrIsValid=' + pnrIsValid;
	request.open("GET", url, false); 
	request.send(null);
	
	if (debug) Main.debug(request.responseText);
	
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	// Get patient information from the AJAX response
	patientInfo = response.patientInfo;

	Main.show('gocancel');
	
	if (!patientInfo.id)
	{
		Main.show('newPatientSection');
		frm.patientCode.value=patientInfo.name;
		setInnerHTML('new.dateOfBirth', patientInfo.dateOfBirth ? patientInfo.dateOfBirth : "---");
		setInnerHTML('new.gender', patientInfo.gender ? patientInfo.gender : "---");
		frm.familyName.focus();
		if (!pnrIsValid)
		{
			setInputStatus('gender', 'Gender and DateOfBirth can\'t be automatically generated for non-standard Personal number', 'warning');
		}
	}
	else
	{
		Main.show('existingPatientSection');
		setInnerHTML('existing.patientCode', patientInfo.name);
		frm.existingFamilyName.value = patientInfo.familyName;
		frm.existingAllFirstNames.value = patientInfo.allFirstNames;
		if (patientInfo.dateOfBirth) setInnerHTML('existing.dateOfBirth', patientInfo.dateOfBirth);
		if (patientInfo.gender) setInnerHTML('existing.gender', patientInfo.gender);
		frm.existingFamilyName.focus();
	}
}

function gotoStep3()
{
	// Check entered case and pnr with AJAX
	var frm = document.forms['reggie'];
	
	if (!patientInfo.id) // new patient
	{
		frm.patientCode.disabled = true;
		frm.familyName.disabled = true;
		frm.allFirstNames.disabled = true;
		patientInfo.familyName = frm.familyName.value;
		patientInfo.allFirstNames = frm.allFirstNames.value;
	}
	else // existing patient
	{
		frm.existingFamilyName.disabled = true;
		frm.existingAllFirstNames.disabled = true;
		patientInfo.familyName = frm.existingFamilyName.value;
		patientInfo.allFirstNames = frm.existingAllFirstNames.value;
	}
	currentStep = 3;
	
	var updateMode = caseInfo.id && caseInfo.patient;
	
	// Generate list of specimen tubes
	var hasLeftSpecimen = false;
	var hasRightSpecimen = false;
	var hasUnknownSpecimen = false;
	var thisCaseLaterality = caseInfo.laterality;
	var hasSpecimen = caseInfo.specimen && caseInfo.specimen.length > 0;
	var thisCasePAD = null;
	var hasPAD = false;
	var thisCaseSamplingDate = null;
	var thisCaseRNALaterDate = null;
	
	if (hasSpecimen)
	{
		var specimenTubes = '';
		Main.hide('reasonIfNoSpecimenSection');	
		for (var i = 0; i < caseInfo.specimen.length; i++)
		{
			var specimen = caseInfo.specimen[i];
			specimenTubes += specimen.name;
			if (specimen.pad && !hasPAD) 
			{
				hasPAD = true;
				thisCasePAD = specimen.pad;
			}
			if (specimen.samplingDate && !thisCaseSamplingDate) 
			{
				thisCaseSamplingDate = specimen.samplingDate;
			}
			if (specimen.rnaLaterDate && !thisCaseRNALaterDate) 
			{
				thisCaseRNALaterDate = specimen.rnaLaterDate;
			}
			if (specimen.laterality) 
			{
				specimenTubes += ' ('+specimen.laterality + ')';
				Forms.checkRadio(frm.laterality, specimen.laterality);
				if (specimen.laterality == 'LEFT') hasLeftSpecimen = true;
				if (specimen.laterality == 'RIGHT') hasRightSpecimen = true;
				if (!thisCaseLaterality) thisCaseLaterality = specimen.laterality;
			}
			else
			{
				hasUnknownSpecimen = true;
				specimenTubes += ' (<i>unknown laterality</i>)';
			}
			specimenTubes += '<br>';
		}
		setInnerHTML('specimenTubes', specimenTubes);
		
		// Check that all specimen tubes have the same laterality
		var numLateralities = 0;
		if (hasLeftSpecimen) numLateralities++;
		if (hasRightSpecimen) numLateralities++;
		if (hasUnknownSpecimen) numLateralities++;
		if (numLateralities > 1)
		{
			setInputStatus('specimenTubes', 'Specimen tubes with different laterality', 'warning');
			thisCaseLaterality = null;
		}
		
		Main.show('samplingDateSection');
		Main.show('rnaLaterDateSection');

	}
	else
	{
		if (caseInfo.noSpecimen)
		{
			// This case is registered with 'NoSpecimen'
			thisCasePAD = caseInfo.noSpecimen.pad;
			thisCaseSamplingDate = caseInfo.noSpecimen.samplingDate;
			frm.reasonIfNoSpecimen.value = caseInfo.noSpecimen.reasonIfNoSpecimen;
		}
		
		// Hide & disable 'Sampling time' field
		Main.hide('samplingTimeField');
		frm.samplingTime.disabled = true;
		
		// Hide 'RNA Later date' field
		Main.hide('rnaLaterDateSection');
	}

	// Populate 'Sampling date' and 'RNA Later date' fields
	if (thisCaseSamplingDate != null)
	{
		frm.samplingDate.value = thisCaseSamplingDate.substring(0, 8);
		if (!frm.samplingTime.disabled)
		{
			frm.samplingTime.value = thisCaseSamplingDate.substring(9, 13);
		}
		samplingDateTimeOnChange();
	}
	if (thisCaseRNALaterDate != null)
	{
		frm.rnaLaterDate.value = thisCaseRNALaterDate.substring(0, 8);
		frm.rnaLaterTime.value = thisCaseRNALaterDate.substring(9, 13);
		rnaLaterDateTimeOnChange();
	}
	
	frm.pad.value = thisCasePAD;
	
	Main.show('caseSection');
	
	// Existing cases for this patient
	var hasLeftCase = false;
	var hasRightCase = false;
	var hasUnknownCase = false;
	if (patientInfo.cases && patientInfo.cases.length > 0)
	{
		var cases = '';
		for (var i = 0; i < patientInfo.cases.length; i++)
		{
			var cc = patientInfo.cases[i];
			if (cc.laterality == 'LEFT') 
			{
				if (hasLeftCase && !updateMode) setInputStatus('laterality', 'Two cases with laterality=LEFT', 'warning');
				hasLeftCase = true;
			}
			else if (cc.laterality == 'RIGHT') 
			{
				if (hasRightCase && !updateMode) setInputStatus('laterality', 'Two cases with laterality=RIGHT', 'warning');
				hasRightCase = true;
			}
			else
			{
				hasUnknownCase = true;	
			}
			if (!updateMode || cc.id == caseInfo.id)
			{
				cases += '<input type="radio" name="laterality" value="' + cc.id + '" id="laterality'+cc.id+'"';
				if (cc.laterality == thisCaseLaterality) cases += ' checked';
				cases += ' onclick="lateralityOnChange()"><label for="laterality' + cc.id + '">';
				if (cc.laterality) 
				{
					cases += cc.laterality;
				}
				else
				{
					cases += '<i>unknown laterality</i>';
				}
				if (!updateMode)
				{
					cases += ' [merge with ' + cc.name + ']';
				}
				cases += '</label><br>';
			}
		}
		
		if (patientInfo.cases.length == 1 || updateMode)
		{
			if (!hasLeftCase)
			{
				cases += '<input type="radio" name="laterality" value="LEFT" id="lateralityLeft"';
				if (thisCaseLaterality == 'LEFT') cases += ' checked';
				cases += ' onclick="lateralityOnChange()"><label for="lateralityLeft">LEFT';
				if (!updateMode) cases += ' [<i>new case</i>]</label>';
				cases += '<br>';
			}
			if (!hasRightCase)
			{
				cases += '<input type="radio" name="laterality" value="RIGHT" id="lateralityRight"';
				if (thisCaseLaterality == 'RIGHT') cases += ' checked';
				cases += ' onclick="lateralityOnChange()"><label for="lateralityRight">RIGHT';
				if (!updateMode) cases += ' [<i>new case</i>]</label>';
				cases += '<br>';
			}
			if (!updateMode && !hasLeftCase && !hasRightCase)
			{
				cases += '<input type="radio" name="laterality" value="" id="lateralityUnknown"';
				if (thisCaseLaterality == null) cases += ' checked';
				cases += ' onclick="lateralityOnChange()"><label for="lateralityUnknown"><i>unknown laterality</i> [<i>new case</i>]</label><br>';
			}
			
			if (!updateMode && patientInfo.cases[0].consent)
			{
				var c = patientInfo.cases[0];
				var html = "From case '" + c.name;
				html += "' (" + c.consent;
				if (c.consentDate) html += '; ' + c.consentDate;
				html += ')';
				setInnerHTML('copyConsent.text', html);	
				frm.copyConsent.value = patientInfo.cases[0].id;
				copyConsentEnabled = true;
			}
			
		}
		
		if (updateMode)
		{
			if (caseInfo.merged)
			{
				setInnerHTML('step3.title', 'Update case \''+caseInfo.originalName+'\' (which is merged with case \'' + caseInfo.name + '\')');
			}
			else
			{
				setInnerHTML('step3.title', 'Update case \''+caseInfo.name+'\'');
			}
			
		}
		else if (patientInfo.cases.length == 2)
		{
			setInnerHTML('step3.title', 'Merge with existing case');	
		}
		else if (patientInfo.cases.length > 0)
		{
			setInnerHTML('step3.title', 'Create new case or merge with existing case');	
		}
		
		setInnerHTML('laterality.input', cases);
	}
	
	// Check the blood registration for consent information
	if (!copyConsentEnabled && bloodInfo && bloodInfo.consent)
	{
		var html = "From blood '" + bloodInfo.name;
		html += "' (" + bloodInfo.consent;
		if (bloodInfo.consentDate) html += '; ' + bloodInfo.consentDate;
		html += ')';
		setInnerHTML('copyConsent.text', html);	
		frm.copyConsent.value = bloodInfo.id;
		copyConsentEnabled = true;
	}

	
	lateralityOnChange();

	Main.hide('gonext');
	if (updateMode)
	{
		Main.show('goupdate');
	}
	else
	{
		Main.show('gocreate');
	}
	
	if (lateralityIsValid) frm.pad.focus();
}

function goCreate()
{
	if (!step3IsValid()) return;
	
	Main.hide('gocreate');
	Main.hide('gocancel');
	Main.hide('goupdate');
	var frm = document.forms['reggie'];

	caseInfo.laterality = Forms.getCheckedRadio(frm.laterality).value;
	caseInfo.reasonIfNoSpecimen = frm.reasonIfNoSpecimen.value;
	caseInfo.pad = frm.pad.value;
	
	// 'C' suffix is only for 'SpecimenCoreBiopsy' items
	var caseName = frm.caseName.value;
	if (caseName.length > 7 && caseName.substring(7, 8) == 'C')
	{
		caseInfo.biopsyType = 'SpecimenCoreBiopsy';
	}
	if (frm.samplingTime.disabled)
	{
		// No time part if no specimen has been received
		caseInfo.samplingDate = Main.trimString(frm.samplingDate.value);
	}
	else
	{
		caseInfo.samplingDate = Main.trimString(frm.samplingDate.value + ' ' + frm.samplingTime.value);
	}
	caseInfo.rnaLaterDate = Main.trimString(frm.rnaLaterDate.value + ' ' + frm.rnaLaterTime.value);
	if (frm.copyConsent.checked && frm.copyConsent.value)
	{
		caseInfo.copyConsent = parseInt(frm.copyConsent.value);
	}

	for (var i = 0; i < frm.laterality.length; i++)
	{
		frm.laterality[i].disabled = true;
	}
	frm.reasonIfNoSpecimen.disabled = true;
	frm.pad.disabled = true;
	frm.samplingDate.disabled = true;
	frm.samplingTime.disabled = true;
	frm.rnaLaterDate.disabled = true;
	frm.rnaLaterTime.disabled = true;
	frm.copyConsent.disabled = true;

	var updateMode = caseInfo.id && caseInfo.patient;
	var submitInfo = new Object();
	submitInfo.patientInfo = patientInfo;
	submitInfo.caseInfo = caseInfo;

	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	var url = 'PersonalRegistration.servlet?ID=<%=ID%>&cmd=';
	url += updateMode ? 'UpdateCase' : 'CreateCase';
	request.open("POST", url, false);
	request.setRequestHeader("Content-Type", "application/json");
	request.send(JSON.stringify(submitInfo));

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gorestart');

}
</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Personal information registration" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 800px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Case + Personal number -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Enter Case Name and Personal Number</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Case name</td>
				<td class="input"><input type="text" name="caseName" 
					size="18" maxlength="12" onblur="caseNameOnChange()" onkeypress="focusOnEnter(event, 'personalNumber')"></td>
				<td class="status" id="case.status"></td>
				<td class="help"><span id="case.message" class="message" style="display: none;"></span>The case (barcode) associated with this patient.</td>
			</tr>
			<tr>
				<td class="prompt">Personal number</td>
				<td class="input"><input type="text" name="personalNumber" 
					size="18" maxlength="12" onkeyup="personalNumberOnChange()" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="pnr.status"></td>
				<td class="help"><span id="pnr.message" class="message" style="display: none;"></span>([YY]YYMMDDZZZZ)</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>

	<!-- 2. New patient registration -->
	<div id="newPatientSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle">New patient: Enter all names</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Patient code</td>
				<td class="input"><input type="text" name="patientCode" 
					value="" size="18" maxlength="12" 
					onkeypress="focusOnEnter(event, 'familyName')"></td>
				<td class="status" id="patientCode.status"></td>
				<td class="help"><span id="patientCode.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Family name</td>
				<td class="input"><input type="text" name="familyName" 
					value="" size="35" maxlength="255"
					onkeypress="focusOnEnter(event, 'allFirstNames')"></td>
				<td class="status" id="familyName.status"></td>
				<td class="help"><span id="familyName.message" class="message" style="display: none;"></span>Keep hyphens, keep åäö, replace all special accented letters [e.g. éèü etc] with standard alphabet character.</td>
			</tr>
			<tr valign="top">
				<td class="prompt">All first names</td>
				<td class="input"><input type="text" name="allFirstNames" 
					size="35" maxlength="255" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="allFirstNames.status"></td>
				<td class="help"><span id="allFirstNames.message" class="message" style="display: none;"></span>Type all names, see FamilyName comment on valid characters.</td>
			</tr>
			<tr>
				<td class="prompt">Gender</td>
				<td class="input" id="new.gender"></td>
				<td class="status" id="gender.status" rowspan="2"></td>
				<td class="help" rowspan="2"><span id="gender.message" class="message" style="display:none;"></span></td>
			</tr>
			<tr>
				<td class="prompt">Date of birth</td>
				<td class="input" id="new.dateOfBirth"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<!-- 2b. Existing patient -->
	<div id="existingPatientSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td class="steptitle">Existing patient: Verify names</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Patient code</td>
				<td class="input" id="existing.patientCode"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Family name</td>
				<td class="input"><input type="text" name="existingFamilyName" 
					value="" size="35" maxlength="255"
					onkeypress="focusOnEnter(event, 'existingAllFirstNames')"></td>
				<td class="status" id="existingFamilyName.status"></td>
				<td class="help"><span id="existingFamilyName.message" class="message" style="display: none;"></span>Keep hyphens, keep åäö, replace all special accented letters [e.g. éèü etc] with standard alphabet character.</td>
			</tr>
			<tr valign="top">
				<td class="prompt">All first names</td>
				<td class="input"><input type="text" name="existingAllFirstNames" 
					size="35" maxlength="255" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="existingAllFirstNames.status"></td>
				<td class="help"><span id="existingAllFirstNames.message" class="message" style="display: none;"></span>Type all names, see FamilyName comment on valid characters.</td>
			</tr>
			<tr>
				<td class="prompt">Gender</td>
				<td class="input" id="existing.gender"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Date of birth</td>
				<td class="input" id="existing.dateOfBirth"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>


	<!-- 3. Case registration -->
	<div id="caseSection" style="display: none;">
	<p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">3</td>
		<td class="steptitle" id="step3.title">Create new case</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt" id="laterality.prompt">Laterality</td>
				<td class="input" id="laterality.input">
					<input type="radio" name="laterality" value="LEFT" id="lateralityLeft" onclick="lateralityOnChange()"><label for="lateralityLeft">LEFT</label><br>
					<input type="radio" name="laterality" value="RIGHT" id="lateralityRight" onclick="lateralityOnChange()"><label for="lateralityRight">RIGHT</label><br>
					<input type="radio" name="laterality" value="" checked id="lateralityUnknown" onclick="lateralityOnChange()"><i><label for="lateralityUnknown">unknown</label></i>
				</td>
				<td class="status" id="laterality.status"></td>
				<td class="help"><span id="laterality.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr id="copyConsentSection" style="display: none;">
				<td class="prompt">Copy consent?</td>
				<td class="input">
					<input type="checkbox" name="copyConsent" id="copyConsent" value="" checked>
					<label for="copyConsent"><span id="copyConsent.text"></span></label>
				</td>
				<td class="status" id="copyConsent.status"></td>
				<td class="help"></td>
			</tr>
			<tr id="padSection" valign="top">
				<td class="prompt">PAD</td>
				<td class="input"><input type="text" name="pad" 
					value="" size="18" maxlength="12" 
					onkeypress="focusOnEnter(event, 'samplingDate')"
					onblur="padOnChange()"></td>
				<td class="status" id="pad.status"></td>
				<td class="help"><span id="pad.message" class="message" style="display: none;"></span></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Specimen tubes</td>
				<td class="input" id="specimenTubes"><i>not found</i></td>
				<td class="status" id="specimenTubes.status"></td>
				<td class="help"><span id="specimenTubes.message" class="message" style="display: none;"></span>The specimen tube(s) associated with this case.</td>
			</tr>
			<tr id="samplingDateSection" valign="top">
				<td class="subprompt">Sampling date</td>
				<td class="input"><input type="text" name="samplingDate" value="" size="12" maxlength="10" 
						onkeypress="focusOnEnter(event, caseInfo.specimen && caseInfo.specimen.length > 0 ? 'samplingTime' : 'reasonIfNoSpecimen')" onblur="samplingDateTimeOnChange()">
					<span id="samplingTimeField">Time <input type="text" name="samplingTime" value="" size="6" maxlength="5" 
						onkeypress="focusOnEnter(event, caseInfo.specimen && caseInfo.specimen.length > 0 ? 'rnaLaterDate' : 'reasonIfNoSpecimen')" onblur="samplingDateTimeOnChange()"></span>
				</td>
				<td class="status" id="samplingDate.status"></td>
				<td class="help"><span id="samplingDate.message" class="message" style="display: none;"></span>Date (+time) of surgical removal (YYYYMMDD, HHMM)</td>
			</tr>
			<tr id="rnaLaterDateSection" valign="top">
				<td class="subprompt">RNA Later date</td>
				<td class="input"><input type="text" name="rnaLaterDate" value="" size="12" maxlength="10"
						onkeypress="focusOnEnter(event, 'rnaLaterTime')" onblur="rnaLaterDateTimeOnChange()">
					Time <input type="text" name="rnaLaterTime" value="" size="6" maxlength="5"
						onblur="rnaLaterDateTimeOnChange()"></td>
				<td class="status" id="rnaLaterDate.status"></td>
				<td class="help"><span id="rnaLaterDate.message" class="message" style="display: none;"></span>Date+time of pathology handling (YYYYMMDD, HHMM)</td>
			</tr>
			<tr id="reasonIfNoSpecimenSection" valign="top">
				<td class="subprompt">Reason if no specimen</td>
				<td class="input"><textarea rows="3" cols="30" name="reasonIfNoSpecimen" value=""></textarea></td>
				<td class="status"></td>
				<td class="help">Comment why there was no specimen tubes in the delivery.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 800px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 800px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
		<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
		<td><base:button id="goupdate" title="Update" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
		<td id="gonext.message" class="message"></td>
	</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>